#ifndef FILE_LapackGEP
#define FILE_LapackGEP

// Eigenvalue problems 

void LaEigNSSolve(int n, double * A, double * B, std::complex<double> * lami, int evecs_bool, double *evecs_re, double *evecs_im, char balance_type);
void LaEigNSSolve(int n, std::complex<double> * A, std::complex<double> * B, std::complex<double> * lami, int evecs_bool, std::complex<double> *evecs, std::complex<double> *dummy, char balance_type);

void LapackSSEP(int n, double* A, double* lami, double* evecs); 

void LapackHessenbergEP (int n, std::complex<double> * H, std::complex<double> * lami, std::complex<double> * evecs); 
void LapackGHEP(int n, double* A, double* B,  double* lami) ; 
void LapackGHEPEPairs(int n, double* A, double* B, double* lami);
// A,B overwritten in A eigenvectors z^H B z = 1  
  
//void LaEigNSSolve(const LaGenMatDouble &A, LaVectorDouble &eigvals);
//void LaEigNSSolveIP(LaGenMatDouble &A, LaVectorDouble &eigvals);

void LaEigNSSolveTest();
void LaLinearSolveComplex(int n, std::complex<double> * A, std::complex<double> * F); 
void LaLinearSolve(int n, double * A, double * F); 

#endif




