#ifndef FILE_NGSTD
#define FILE_NGSTD

#include <cstring>
#include <cstdlib>

/*********************************************************************/
/* File:   ngstd.hpp                                                 */
/* Author: Joachim Schoeberl                                         */
/* Date:   25. Mar. 2000                                             */
/*********************************************************************/

/* 
   ng-standard classes
*/



namespace netgen
{
#include "../../libsrc/general/parthreads.hpp"
#include "../../libsrc/general/moveablemem.hpp"
#include "../../libsrc/general/dynamicmem.hpp"
#include "../../libsrc/general/parthreads.hpp"


  extern ::std::ostream * testout;
  extern ::std::ostream * mycout; 
}

using netgen::MoveableMem;
using netgen::DynamicMem;
using netgen::NgLock;
using netgen::NgMutex;

using netgen::testout;
using netgen::mycout; 

/// namespace for standard data types and algorithms
namespace ngstd
{
  using namespace std;

#include "../ngs_defines.hpp"
  
#include "templates.hpp"
#include "exception.hpp"
#include "localheap.hpp"
  
#include "array.hpp"
#include "table.hpp"
#include "symboltable.hpp"
#include "hashtable.hpp"
#include "bitarray.hpp"

#include "blockalloc.hpp"
#include "autoptr.hpp"
#include "memusage.hpp"
#include "flags.hpp"
#include "evalfunc.hpp"
#include "autodiff.hpp"
}

#endif
